unit Main;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls, Buttons, ExtCtrls;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    procedure Button1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private

  public

  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    psapi;

(*
    ===========================================================================
    vZXIDɊ֌W郂W[tpX
    ---------------------------------------------------------------------------
    XP, 2003, 2000(Pro/Svr), NT(WS/Svr) 
    ---------------------------------------------------------------------------
    ms-help://MS.PSDK.1033/perfmon/base/enumerating_all_modules_for_a_process.htm
    ===========================================================================
*)
procedure   PrintModules(AProcID: Cardinal; AResults: TStrings);
const
    MAX_HMODULE = 1024;
var
    DesiredAccess: Cardinal;                        //  tO
    ModHandle : array[0..MAX_HMODULE-1] of HMODULE; //  W[nh
    ProcHandle: THandle;                            //  vZXnh
    cbNeeded  : DWORD;                              //  z̑傫
    i         : integer;
    p         : PChar;
    ModNameLen: integer;                            //  W[
    ModName   : string;                             //  W[
begin
    //  Ƃ肠vZXIDo͂Ă
    AResults.Add(Format('Process ID: %d', [AProcID]));
    //  vZX̃nho
    DesiredAccess := PROCESS_QUERY_INFORMATION or PROCESS_VM_READ;
    ProcHandle := OpenProcess(DesiredAccess, false, AProcID);
    //  sH
    if (ProcHandle = INVALID_HANDLE_VALUE) then
    begin
        Exit;
    end
    //  I
    else
    begin
        try
            //  ̃vZX̑SẴW[̃Xg擾(pspi.dll)
            if (EnumProcessModules(ProcHandle, @ModHandle, MAX_HMODULE, cbNeeded)) then
            begin
                //  W[̌JԂ܂傤
                for i := 0 to (cbNeeded div sizeof(HMODULE)) - 1 do
                begin
                    //  m
                    GetMem(p, MAX_PATH);
                    //  W[t@C̃tpX擾
                    ModNameLen := GetModuleFileNameEx(ProcHandle, ModHandle[i], p, MAX_PATH);
                    //  
                    SetString(ModName, p, ModNameLen);
                    //  
                    FreeMem(p);
                    //  Xgɒǉ
                    AResults.Add(Format('%s (%8d)', [ModName, ModHandle[i]]));
                end;
            end;
        finally
            //  J߂
            CloseHandle(ProcHandle);
        end;
    end;
end;

(*
    ===========================================================================
    }EX̉ɂEBhẼvZXIDɊ֘A郂W[
    ===========================================================================
*)
procedure TMainForm.Button1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
    Pnt : TPoint;
    WH  : HWND;
    ProcessID{, ThreadID}: integer;
begin
    //  Ƃ̂ŃNA
    Memo1.Lines.Clear;
    //  }EXƂ̍W
    Pnt := Point(X, Y);
    //  ̍WXN[Wɕϊ
    Pnt := TControl(Sender).ClientToScreen(Pnt);
    //  ϊW\
    Memo1.Lines.Add(Format('Mouse X:%3.3d Y:%3.3d', [Pnt.X, Pnt.Y]));
    //  ̈ʒuɂEBhẼnh
    WH := WindowFromPoint(Pnt);
    //  LłH
    if (WH <> 0) then
    begin
        //  ̃EBhẼvZXID́H
        {ThreadID := }GetWindowThreadProcessId(WH, @ProcessID);
        //  ł̃W[́H
        PrintModules(ProcessID, Memo1.Lines);
    end;
end;

end.

